# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 2.3.33.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model
from msrest.exceptions import HttpOperationError


class ModelErrorResponse(Model):
    """Model Management Service Error object.

    :param code: error code
    :type code: str
    :param status_code: HTTP status code
    :type status_code: int
    :param message: Error message
    :type message: str
    :param details: An array of error detail objects.
    :type details: list[~_restclient.models.ErrorDetail]
    """

    _validation = {
        'code': {'required': True},
        'message': {'required': True},
    }

    _attribute_map = {
        'code': {'key': 'code', 'type': 'str'},
        'status_code': {'key': 'statusCode', 'type': 'int'},
        'message': {'key': 'message', 'type': 'str'},
        'details': {'key': 'details', 'type': '[ErrorDetail]'},
    }

    def __init__(self, code, message, status_code=None, details=None):
        super(ModelErrorResponse, self).__init__()
        self.code = code
        self.status_code = status_code
        self.message = message
        self.details = details


class ModelErrorResponseException(HttpOperationError):
    """Server responsed with exception of type: 'ModelErrorResponse'.

    :param deserialize: A deserializer
    :param response: Server response to be deserialized.
    """

    def __init__(self, deserialize, response, *args):

        super(ModelErrorResponseException, self).__init__(deserialize, response, 'ModelErrorResponse', *args)
