# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 2.3.33.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class RootError(Model):
    """The root error.

    :param code: The service-defined error code.
    :type code: str
    :param message: A human-readable representation of the error.
    :type message: str
    :param target: The target of the error (e.g., the name of the property in
     error).
    :type target: str
    :param details: The related errors that occurred during the request.
    :type details: list[~_restclient.models.RootError]
    :param inner_error: A nested list of inner errors. When evaluating errors,
     clients MUST traverse through all of the nested “innerErrors” and choose
     the deepest one that they understand.
    :type inner_error: ~_restclient.models.InnerErrorResponse
    :param debug_info: An internal representation of the error. May be null
     for non-AzureML services.
    :type debug_info: ~_restclient.models.DebugInfoResponse
    """

    _attribute_map = {
        'code': {'key': 'code', 'type': 'str'},
        'message': {'key': 'message', 'type': 'str'},
        'target': {'key': 'target', 'type': 'str'},
        'details': {'key': 'details', 'type': '[RootError]'},
        'inner_error': {'key': 'innerError', 'type': 'InnerErrorResponse'},
        'debug_info': {'key': 'debugInfo', 'type': 'DebugInfoResponse'},
    }

    def __init__(self, code=None, message=None, target=None, details=None, inner_error=None, debug_info=None):
        super(RootError, self).__init__()
        self.code = code
        self.message = message
        self.target = target
        self.details = details
        self.inner_error = inner_error
        self.debug_info = debug_info
