# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 2.3.33.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class ServiceResponseBase(Model):
    """The base service response. The correct inherited response based on
    computeType will be returned (ex. ACIServiceResponse).

    You probably want to use the sub-classes and not this class directly. Known
    sub-classes are: ACIServiceResponse, AKSServiceResponse

    :param created_time: The time the service was created.
    :type created_time: datetime
    :param deployment_type: The deployment type for the service. Possible
     values include: 'GRPCRealtimeEndpoint', 'HttpRealtimeEndpoint'
    :type deployment_type: str or ~_restclient.models.DeploymentType
    :param description: The service description.
    :type description: str
    :param error: The error details.
    :type error: ~_restclient.models.ModelErrorResponse
    :param id: The service Id.
    :type id: str
    :param kv_tags: The service tag dictionary. Tags are mutable.
    :type kv_tags: dict[str, str]
    :param name: The service name.
    :type name: str
    :param properties: The service property dictionary. Properties are
     immutable.
    :type properties: dict[str, str]
    :param state: The current state of the service. Possible values include:
     'Transitioning', 'Healthy', 'Unhealthy', 'Failed'
    :type state: str or ~_restclient.models.WebServiceState
    :param tags: The service tag list.
    :type tags: list[str]
    :param updated_time: The time the service was updated.
    :type updated_time: datetime
    :param compute_type: Constant filled by server.
    :type compute_type: str
    """

    _validation = {
        'compute_type': {'required': True},
    }

    _attribute_map = {
        'created_time': {'key': 'createdTime', 'type': 'iso-8601'},
        'deployment_type': {'key': 'deploymentType', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'error': {'key': 'error', 'type': 'ModelErrorResponse'},
        'id': {'key': 'id', 'type': 'str'},
        'kv_tags': {'key': 'kvTags', 'type': '{str}'},
        'name': {'key': 'name', 'type': 'str'},
        'properties': {'key': 'properties', 'type': '{str}'},
        'state': {'key': 'state', 'type': 'str'},
        'tags': {'key': 'tags', 'type': '[str]'},
        'updated_time': {'key': 'updatedTime', 'type': 'iso-8601'},
        'compute_type': {'key': 'computeType', 'type': 'str'},
    }

    _subtype_map = {
        'compute_type': {'ACI': 'ACIServiceResponse', 'AKS': 'AKSServiceResponse'}
    }

    def __init__(self, created_time=None, deployment_type=None, description=None, error=None, id=None, kv_tags=None, name=None, properties=None, state=None, tags=None, updated_time=None):
        super(ServiceResponseBase, self).__init__()
        self.created_time = created_time
        self.deployment_type = deployment_type
        self.description = description
        self.error = error
        self.id = id
        self.kv_tags = kv_tags
        self.name = name
        self.properties = properties
        self.state = state
        self.tags = tags
        self.updated_time = updated_time
        self.compute_type = None
